/*******************
VARIABLES
*******************/
var videoRef, videoThumb, closeBtn, panelView, panelCollapseView, clickthroughExpandBtn, clickthroughCollapseBtn, videoContainerRef, playPauseBtn, muteUnmuteBtn, lastFrame;
/*******************
INITIALIZATION
*******************/
function checkIfAdKitReady(event) {
	adkit.onReady(initializeCreative);
}

function initializeCreative() {
    //createImmersiveTakeoverInstance();
    
	initializeGlobalVariables();
    lastFrame.src = EB.getAssetUrl('../../AdditionalAssets/video.jpg',2);
    
    let root = document.documentElement;
    
    root.style.setProperty('--IMG_320','url(' +  EB.getAssetUrl('../../AdditionalAssets/SF_320.png',101) + ')');
    root.style.setProperty('--IMG_480','url(' +  EB.getAssetUrl('../../AdditionalAssets/SF_480.png',102) + ')');
    root.style.setProperty('--IMG_768','url(' +  EB.getAssetUrl('../../AdditionalAssets/SF_768.png',103) + ')');
    root.style.setProperty('--IMG_970','url(' +  EB.getAssetUrl('../../AdditionalAssets/SF_970.png',104) + ')');
    root.style.setProperty('--IMG_1180','url(' +  EB.getAssetUrl('../../AdditionalAssets/SF_1180.png',105) + ')');

	addEventListeners();
}

function initializeGlobalVariables() {
	panelView = document.getElementById("panelView");
	videoContainerRef = document.getElementById("video-container");
    playPauseBtn = document.getElementById("play-pause");
    muteUnmuteBtn = document.getElementById("mute-unmute");
    lastFrame = document.getElementById("lastframe");
}

function addEventListeners() {
	document.body.addEventListener("click", onClickthrough);
    videoContainerRef.addEventListener("click", onClickthroughVideo);
	window.addEventListener("resize", onWindowResize);
    playPauseBtn.addEventListener("click", toggleVideoPlay);
    muteUnmuteBtn.addEventListener("click",toggleAudio );
}
/*******************
EVENT HANDLERS
*******************/
function onClickthrough(e) {
    myStopPropagation(e);
	EB.clickthrough("click_header");
}
function onClickthroughVideo(e) {
    myStopPropagation(e);
	EB.clickthrough("click_videoplayer");
}

function toggleVideoPlay(e){
    myStopPropagation(e);
    if(checkVideoPlaying()){
        video.pause();
        setBtnStatusTo("play");
    }else{
        video.play();
        setBtnStatusTo("pause");
    }
}

function toggleAudio(e){
    myStopPropagation(e);
     if(video.muted){
       video.muted = false;
        setBtnStatusTo("mute");
    }else{
       video.muted = true;
        setBtnStatusTo("unmute");
    }
}

function showLastframe(){
    lastFrame.style.opacity = 1;
}
function hideLastframe(){
    lastFrame.style.opacity = 0;
}

function setBtnStatusTo(_status){
    switch(_status) {
      case "play":
        playPauseBtn.children[0].src = "images/controls/svg_2/play.svg";
        break;
      case "pause":
        playPauseBtn.children[0].src = "images/controls/svg_2/pause.svg";
        break;
    case "mute":
        muteUnmuteBtn.children[0].src = "images/controls/svg_2/unmute.svg";
        break;
    case "unmute":
         muteUnmuteBtn.children[0].src = "images/controls/svg_2/mute.svg";
        break;
    case "replay":
        playPauseBtn.children[0].src = "images/controls/svg_2/replay.svg";
        break;
      default:
        // code block
    }
}

function checkVideoPlaying(){
    if(video.currentTime > 0 && !video.paused && !video.ended){
        return true;
    }else{
        return false;
    }
}

/*******************
CALLBACK FUNCTIONS
*******************/
function afterShowPanelContent() {
	//Implement code logic to fire when the panel is shown
	//resizeFont();
	//initVideo: will add the video interactions for tracking and you will able to use the callbacks for the video(afterVideoEnd,afterVideoPlay,afterVideoPause,afterVolumeChange)

	immersiveTakeover.initVideo(videoContainerRef);
}

/*******************
CALLBACK VIDEO FUNCTIONS
*******************/
function afterVideoReady(args) {
	//Implement code logic to fire when the video ready / video tag injected into the page
	videoRef = args.video;
}

function afterVideoEnd(args) {
	//Implement code logic to fire when the video End
    setBtnStatusTo("replay");
    showLastframe();
}

function afterVideoPlay(args) {
	//Implement code logic to fire when the video Play
    setBtnStatusTo("pause");
    hideLastframe();
}

function afterVideoPause(args) {
	//Implement code logic to fire when the video Pause
   setBtnStatusTo("play");
   hideLastframe();
}

function afterVolumeChange(args) {
	//Implement code logic to fire when the volume Change
}

function adWasClicked(args) {
	if (args.isMobile && !args.isIOS) {
		videoRef.load();
		setTimeout(function() {
			videoRef.pause();
		}, 100);
	}
	else {
		videoRef.pause();
	}
}
/*******************
CREATIVE FUNCTIONS
*******************/
function onWindowResize(args) {
	//resizeFont();
	//resizeVideo will modify the size of the video respect to the video container you send.
	//immersiveTakeover.resizeVideo(videoContainerRef);
}

function resizeFont() {
	//fontResize(elemRef, minFontSize) is an utility to resize the fontSize depending on the width of the panel
	immersiveTakeover.fontResize(clickthroughExpandBtn, 4);
	immersiveTakeover.fontResize(clickthroughCollapseBtn, 4);
}

function myStopPropagation(e){
	
	if (!e)
	  e = window.event;

	//IE9 & Other Browsers
	if (e.stopPropagation) {
	  e.stopPropagation();
	}
	//IE8 and Lower
	else {
	  e.cancelBubble = true;
	}
}

/*******************
END OF CREATIVE FUNCTIONS
*******************/
//config = {
//		panel: define the type of the element for the immersiveTakeover, //options: header, left_gutter, right_gutter, background, videoskin, controls or standard
//in the case you want to use the resizeVideo function in the panel with video to get a good aspectRatio, you will need:
//      videoWidth: width of your video,
//      videoHeight: height of your video
// To set video source URL use the following.
// For single video codec use a string as the value.  EG: videoPoster: "videos/video1.jpg"
// For multiple video codecs use an array.  EG: videoPoster: ["videos/video1.mp4", "videos/video1.webm"]
//		videoURL: "videos/video1.mp4",
// To set video poster image source URL use the following.
//		videoPoster: "videos/video1.jpg"
//};

 var config = {
        panel: "header",
        videoWidth: 1100,
        videoHeight: 416,
        videoURL: 'videos/video.mp4', // For multiple codecs use an array.  EG: ["videos/video1.mp4", "videos/video1.webm"]
        videoPoster: '../../AdditionalAssets/video.jpg'
    };
    
var immersiveTakeover = new immersiveTakeover(config);
window.addEventListener("load", checkIfAdKitReady);
