//******************************************************************************
// This class is part of the Sizmek ImmersiveTakeover and SimpleSkin Formats
// ALL RIGHTS RESERVED TO © 2018 Sizmek.
//******************************************************************************
//******************************************************************************
(function() {
	window.immersiveTakeover = function(_c) {
		"use strict";
		/*******************
		VARIABLES
		*******************/
		var config = _c;
		var creativeId;
		var scriptName = "immersiveTakeover";
		var creativeVersion = "1.5.1";
		var lastModified = "2018-08-15";
		var lastUploaded = "2018-08-15";

		var templateVersion = "2.0.24";
		var dimensions;
		var scrollPos = {
			x: 0,
			y: 0
		};
		var isDebug = false;
		var isLocal = false;

		var listenerQueue;
		var creativeIFrameId;

		var adId;
		var rnd;
		var uid;

		var showPanelContentID;
		var panelName;
		var autoEventName;

		var isMobile = false;
		var isIOS = false;
		var isUnsupportedBrowserAutoPlay = true;
		//Panels
		var showPanelContentTimeOut;
		var isAutoExpand = false;
		var userInteraction = false;
		var autoCollapseTimeOut = 0;
		var isCollapsing = false;
		var autoExpandDelay = 0;
		var isExpanded = false;
		var isUserExpanded = false;
		var autoExpandTimer;
		var autoCollapseTimer;
		var animDelay;
		var video;
		var videoTrackingModule;
		var videoConfig = {};
		var initialPosition;
		var expandedPosition;
		var collapsedPosition;
		//Videoskin
		var bannerYMobile = 0;
		var bannerHeightMobile = 250;
		var videoContainer;
		var expandToFullScreen;
		var headerPanelName;
		var leftGutterName;
		var rightGutterName;
		var controlPanelName;
		/*******************
			VARIABLES
		*******************/
		/*******************
		INITIALIZATION
		*******************/
		var registerInteraction = function() {
			//Gutters when the panels are shown
			EB.automaticEventCounter("left_gutter_viewed");
			EB.automaticEventCounter("right_gutter_viewed");

			//Header when the panel is expanded by user/auto
			EB.userActionCounter("expand_immersiveTakeover_user");
			EB.automaticEventCounter("expand_immersiveTakeover_auto");

			//Header when the panel is collapsed by user/auto
			EB.userActionCounter("collapse_immersiveTakeover_user");
			EB.automaticEventCounter("collapse_immersiveTakeover_auto");

			//mdPageBackground with clickable option
			EB.clickthrough("clickable_gutters");
		};

		// Create Event Handlers for class
		var addEventListener = function(_e, _m, _b) {
			window.addEventListener(_e, _m, _b);
		};

		// Remove Event Handlers for class
		var removeEventListener = function(_e, _m, _b) {
			window.removeEventListener(_e, _m, _b);
		};

		window.addEventListener("message", function() {
			try {
				eventManager.apply(this, arguments);
			}
			catch (e) {}
		}, false);
		// Leave from the FullScreen option
		window.leaveFullScreen = function() {
			if (document.exitFullscreen) {
				document.exitFullscreen();
			}
			else if (document.webkitExitFullscreen) {
				document.webkitExitFullscreen();
			}
			else if (document.mozCancelFullscreen) {
				document.mozCancelFullscreen();
			}
		};

		// Call Init Method once AdKit is loaded
		adkit.onReady(function() {
			init();
		});

		var init = function() {
			//by default will be "banner"
			if (typeof config == "undefined") {
				config = {
					panel: "banner"
				};
			}
			creativeId = typeof config.panel !== "undefined" && config.panel !== "" ? config.panel : "banner";
			videoConfig.width = typeof config.videoWidth !== "undefined" && config.videoWidth !== "" ? config.videoWidth : 640;
			videoConfig.height = typeof config.videoHeight !== "undefined" && config.videoHeight !== "" ? config.videoHeight : 360;
			videoConfig.videoURL = typeof config.videoURL !== "undefined" && config.videoURL !== "" ? config.videoURL : "";
			videoConfig.videoPoster = typeof config.videoPoster !== "undefined" && config.videoPoster !== "" ? config.videoPoster : "";
			initialPosition = typeof config.initialPosition !== "undefined" && config.initialPosition !== "" ? config.initialPosition : "top-center";
			expandedPosition = typeof config.expandedPosition !== "undefined" && config.expandedPosition !== "" ? config.expandedPosition : "top-center";
			collapsedPosition = typeof config.collapsedPosition !== "undefined" && config.collapsedPosition !== "" ? config.collapsedPosition : "top-right";
			/* restart the panel and the total of panels is wrong in the customScript
			try {
				// so messaging can work in safe frames we need to bind the events that are present in the event manager.
				EBG.pm.bind("sendCreativeId", function () {
					eventManager.apply(this, arguments);
				}, this);
				EBG.pm.bind("eventCallback", function () {
					eventManager.apply(this, arguments);
				}, this);
			}
			catch (e) {}
			*/

			//Workaround (from QB6573) for Async EB Load where Modernizr isn't properly initialized
			typeof Modernizr == "object" && (Modernizr.touch = Modernizr.touch || "ontouchstart" in window);

			initializeGlobalVariables();
			window.registerInteraction = function() {}; //overwrite rI function because it will never actually be called
		};

		var isUnsupportedBrowser = function() {
			// NOTE: Android v4 native browser - known issue.
			// 			Video can only be controlled via native video controls.
			//  		Video will auto play but a user can not pause, restart, etc. the video.
			//  		This is only affecting the videoskin as the video template contains native controls.

			// iOS 9 and below do not allow auto play video
			var iOS_v9AndBelow = EB.API.os.ios && EB.API.os.ver <= 9;

			// samsung browser 6 and below will not auto play.
			var samsungBrowser_v6AndBelow = EB.API.os.ua.match(/(?:SAMSUNG.*?SamsungBrowser\/[123456])/);

			return (iOS_v9AndBelow || samsungBrowser_v6AndBelow);
		};

		var initializeGlobalVariables = function() {
			if (typeof EB._isLocalMode === "undefined" || EB._isLocalMode) {
				isLocal = true;
			}
			adId = isLocal ? 0 : EB._adConfig.adId;
			rnd = isLocal ? 0 : EB._adConfig.rnd;
			uid = isLocal ? 0 : EB._adConfig.uid;

			isMobile = isLocal ? false : EB.API.os.mobile;
			isIOS = isLocal ? false : EB.API.os.ios;

			isUnsupportedBrowserAutoPlay = isLocal ? false : isUnsupportedBrowser();

			isAutoExpand = isLocal ? isAutoExpand : EB.API.getCustomVar("mdIsAutoExpand");

			switch (creativeId) {
				case "banner":
					animDelay = typeof config.showDelay != "undefined" && config.showDelay !== "" ? config.showDelay : 0;
					showPanelContent();
					break;
				case "standard":
					animDelay = typeof config.showDelay != "undefined" && config.showDelay !== "" ? config.showDelay : 0;
					showPanelContent();
					break;
				case "header":
					animDelay = typeof config.showDelay != "undefined" && config.showDelay !== "" ? config.showDelay : 500;
					panelName = isLocal ? "" : EB.API.getCustomVar("mdHeaderPanelName");
					autoCollapseTimeOut = isLocal ? 0 : parseInt(EB.API.getCustomVar("mdAutoCollapseTimeout"));
					autoExpandDelay = isLocal ? 0 : parseInt(EB.API.getCustomVar("mdAutoExpandDelay"));
					break;
				case "right_gutter":
					animDelay = typeof config.showDelay != "undefined" && config.showDelay !== "" ? config.showDelay : 1500;
					autoEventName = "right_gutter_viewed";
					panelName = isLocal ? "" : EB.API.getCustomVar("mdRightGutterName");
					if (!isLocal) trackGutters();
					break;
				case "left_gutter":
					animDelay = typeof config.showDelay != "undefined" && config.showDelay !== "" ? config.showDelay : 1500;
					panelName = isLocal ? "" : EB.API.getCustomVar("mdLeftGutterName");
					autoEventName = "left_gutter_viewed";
					if (!isLocal) trackGutters();
					break;
				case "background":
					animDelay = typeof config.showDelay != "undefined" && config.showDelay !== "" ? config.showDelay : 500;
					panelName = isLocal ? "" : EB.API.getCustomVar("mdBackgroundPanelName");
					break;
				case "videoskin":
					animDelay = typeof config.showDelay != "undefined" && config.showDelay !== "" ? config.showDelay : 1500;
					panelName = isLocal ? "" : EB.API.getCustomVar("mdBackgroundPanelName");
					expandToFullScreen = isLocal ? "" : EB.API.getCustomVar("mdExpandToFullScreen");
					headerPanelName = isLocal ? "" : EB.API.getCustomVar("mdHeaderPanelName");
					leftGutterName = isLocal ? "" : EB.API.getCustomVar("mdLeftGutterName");
					rightGutterName = isLocal ? "" : EB.API.getCustomVar("mdRightGutterName");
					controlPanelName = isLocal ? "" : EB.API.getCustomVar("mdControlPanelName");
					break;
				case "controls":
					animDelay = typeof config.showDelay != "undefined" && config.showDelay !== "" ? config.showDelay : 500;
					break;
			}
			if (isLocal) {
				showPanelContent();
			}
			else {
				if (creativeId !== "banner") {
					clearTimeout(showPanelContentTimeOut);
					showPanelContentTimeOut = setTimeout(function() {
						log("TimeOut: ShowPanelContent_emergency_mode: " + creativeId);
						showPanelContent();
					}, 8000);
				}
				else {
					initializeDomainConfig();
				}
			}
		};

		var initializeDomainConfig = function(domainConfig) {
			if (typeof domainConfig != "undefined") {
				EB._sendMessage("setDomainDetails", {
					domainDetails: domainConfig,
					uid: uid
				});
			}
			else {
				//Expand all Panels
				EB._sendMessage("initPanels", {
					uid: uid
				});
			}
		};

		var getInfo = function() {
			return {
				isLocal: isLocal,
				isMobile: isMobile,
				isIOS: isIOS,
				isUnsupportedBrowserAutoPlay: isUnsupportedBrowserAutoPlay
			};
		};

		var showPanelContent = function(e) {
			log("ShowPanel: " + creativeId);
			clearTimeout(showPanelContentTimeOut);
			addCustomScriptEventListener("closePanel", closePanel);
			//Sync features for all panels
			addCustomScriptEventListener("animateAll", syncAll);
			addCustomScriptEventListener("clickThroughFired", onClickThroughFired);
			switch (creativeId) {
				case "header":
					addCustomScriptEventListener("clearAutoCollapseTimer", clearAutoCollapseTimer);
					removeCustomScriptEventListener(showPanelContentID);
					break;
				case "right_gutter":
					removeCustomScriptEventListener(showPanelContentID);
					//Sync
					isFunctionAddCustomScriptEventListener("animateRight", "syncGutterRight");
					break;
				case "left_gutter":
					removeCustomScriptEventListener(showPanelContentID);
					//Sync
					isFunctionAddCustomScriptEventListener("animateLeft", "syncGutterLeft");
					break;
				case "videoskin":
					//VideoSkin
					isFunctionAddCustomScriptEventListener("pauseVideo", "pauseVideo");
					isFunctionAddCustomScriptEventListener("playVideo", "playVideo");
					isFunctionAddCustomScriptEventListener("toggleVideoPlay", "onToggleVideoPlay");
					isFunctionAddCustomScriptEventListener("toggleAudio", "onToggleAudioControls");
					setTimeout(function() {
						if (typeof videoContainer === "undefined") {
							videoContainer = document.getElementById("video-container");
						}
						if (videoContainer) {
							initVideo(videoContainer);
						}
					}, 200);

					//break is not necesary because VideoSkin option needs continue to background functions
				case "background":
					removeCustomScriptEventListener(showPanelContentID);
					//Sync
					isFunctionAddCustomScriptEventListener("animateLeft", "syncBackgroundLeft");
					isFunctionAddCustomScriptEventListener("animateRight", "syncBackgroundRight");
					//wallpaper
					addCustomScriptEventListener("panelExpanded", onPanelExpanded);
					addCustomScriptEventListener("panelCollapsed", onPanelCollapsed);
					addCustomScriptEventListener("expandAnimStart", onExpandAnimStart);
					addCustomScriptEventListener("expandAnimComplete", onExpandAnimComplete);
					addCustomScriptEventListener("collapseAnimStart", onCollapseAnimStart);
					addCustomScriptEventListener("collapseAnimComplete", onCollapseAnimComplete);
					break;
				case "controls":
					removeCustomScriptEventListener(showPanelContentID);
					dispatchCustomScriptEvent("animateControlPos", {
						pos: initialPosition
					});
					setPanelZIndex(5);
					break;
			}
			setTimeout(function() {
				panelContentFadeIn();
			}, animDelay);
		};

		var panelContentFadeIn = function(e) {
			document.body.addEventListener("webkitAnimationEnd", AnimationEnd, false);
			document.body.addEventListener("animationend", AnimationEnd, false);
			if (EB.browserSupports("cssanimations")) {
				setStyle(document.body, {
					opacity: 1,
					display: "block"
				});
				document.body.classList.add("panelFadeIn");
			}
			else {
				animate(document.body, "opacity", "", 0, 1, 500, AnimationEnd());
			}
			setTimeout(function() {
				isFunctionCallBack("afterShowPanelContent", {
					isUserExpanded: isUserExpanded,
					isMobile: isMobile,
					isExpanded: isExpanded,
					isAutoExpand: isAutoExpand
				});
			}, 100);
			if (creativeId === "header") {
				if (isAutoExpand) {
					setTimeout(function() {
						autoExpand();
					}, 500);
				}
			}
		};

		//AutoExpand panel//
		var autoExpand = function() {
			log("autoexpand: " + creativeId);

			if (autoExpandDelay > 0) {
				clearTimeout(autoExpandTimer);
				autoExpandTimer = setTimeout(function() {
					onExpandClick();
				}, (autoExpandDelay * 1000));
			}
			else {
				onExpandClick();
			}
		};

		var disableAutoExpand = function() {
			log("disableAutoExpand: " + creativeId);
			isUserExpanded = true;
			isAutoExpand = false;
			userInteraction = true;
			clearAutoExpand();
			clearAutoCollapseTimer();
		};
		//AutoExpand panel//

		//AutoCollapse panel//
		var startAutoCollapseTimer = function() {
			log("StartAutoCollapseTimer: creativeId: " + creativeId + "  autoCollapseTimeOut: " + autoCollapseTimeOut + " autoCollapseTimer: " + autoCollapseTimer);
			if (autoCollapseTimeOut > 0) {
				clearTimeout(autoCollapseTimer);
				autoCollapseTimer = setTimeout(function() {
					onCollapseClick();
					clearAutoCollapseTimer();
				}, (autoCollapseTimeOut * 1000));
			}
			document.addEventListener("mousedown", clearAutoCollapseTimer);
		};

		var clearAutoExpand = function() {
			log("clearAutoExpand: " + creativeId);
			isAutoExpand = false;
			if (autoExpandTimer) clearTimeout(autoExpandTimer);
		};

		var clearAutoCollapseTimer = function() {
			log("clearAutoCollapse: " + creativeId);
			userInteraction = true;
			isAutoExpand = false;
			if (creativeId !== "header") {
				log("dispatchCustomScriptEvent: creativeId: " + creativeId + " autoCollapseTimer: " + autoCollapseTimer);
				dispatchCustomScriptEvent("clearAutoCollapseTimer", {});
			}
			else {
				log("clearAutoExpand creativeId: " + creativeId + " autoCollapseTimer: " + autoCollapseTimer);
				document.removeEventListener("mousedown", clearAutoCollapseTimer);
				clearAutoExpand();
				clearTimeout(autoCollapseTimer);
			}

		};
		//AutoCollapse panel//

		var onPanelExpanded = function(args) {
			log("onPanelExpanded: " + creativeId);
			if (creativeId === "controls") {
				isFunctionCallBack("updateExpandCollapseState", {
					isUserExpanded: isUserExpanded,
					isMobile: isMobile,
					isExpanded: true,
					isAutoExpand: isAutoExpand
				});
			}
		};

		var onPanelCollapsed = function(args) {
			isExpanded = false;
			if (creativeId === "controls") {
				dispatchCustomScriptEvent("animateControlPos", {
					pos: collapsedPosition
				});
				isFunctionCallBack("updateExpandCollapseState", {
					isUserExpanded: isUserExpanded,
					isMobile: isMobile,
					isExpanded: isExpanded,
					isAutoExpand: isAutoExpand
				});
			}
		};

		var expand = function() {
			log("expand: " + creativeId);
			if (isAutoExpand) {
				EB.automaticEventCounter("expand_immersiveTakeover_auto");
			}
			else {
				EB.userActionCounter("expand_immersiveTakeover_user");
			}

			switch (creativeId) {
				case "header":
					dispatchCustomScriptEvent("panelExpanded", {
						animate: true
					});
					break;
				case "controls":
					dispatchCustomScriptEvent("panelExpanded", {
						animate: true
					});
					dispatchCustomScriptEvent("animateControlPos", {
						pos: expandedPosition
					});
					break;
			}
			if (typeof video !== "undefined") {
				video.currentTime = 0;
			}
			//LocalTest
			if (isLocal) {
				onExpandAnimStart();
				setTimeout(function() {
					onExpandAnimComplete();
				}, 300);
			}
		};

		var collapse = function() {
			if (isCollapsing) return;
			isExpanded = false;
			isAutoExpand = false;
			switch (creativeId) {
				case "header":
					dispatchCustomScriptEvent("panelCollapsed", {
						animate: true
					});
					break;
				case "controls":
					dispatchCustomScriptEvent("animateControlPos", {
						pos: collapsedPosition
					});
					break;
			}
			try {
				pauseVideo();
				if (window.leaveFullScreen) window.leaveFullScreen();
			}
			catch (e) {}
			//LocalTest only
			if (isLocal) {
				if (creativeId === "header") {
					onCollapseAnimStart();
					setTimeout(function() {
						onCollapseAnimComplete();
					}, 300);
				}
			}
		};

		var closePanel = function(isAuto) {
			isExpanded = false;
			try {
				pauseVideo();
				if (typeof video !== "undefined") {
					if (window.leaveFullScreen) window.leaveFullScreen();
				}
			}
			catch (e) {}
			if (adkit.environment.adParts) {
				EB.collapse({
					panelName: adkit.environment.adParts.name,
					actionType: (isAuto) ? EBG.ActionType.AUTO : EBG.ActionType.USER
				});
			}
		};

		var closeAllPanels = function() {
			isExpanded = false;
			try {
				dispatchCustomScriptEvent("closePanel", {});
				closePanel(true);
			}
			catch (e) {}
		};

		var onExpandClick = function(e) {
			log("onExpandClick: " + creativeId);
			expand();
			if (creativeId === "controls") {
				isFunctionCallBack("updateExpandCollapseState", {
					isUserExpanded: isUserExpanded,
					isMobile: isMobile,
					isExpanded: isExpanded,
					isAutoExpand: isAutoExpand
				});
			}
		};

		var onCollapseClick = function(e) {
			if (isCollapsing) return;
			log("onCollapseClick: " + creativeId);
			if (isAutoExpand) {
				EB.automaticEventCounter("collapse_immersiveTakeover_auto");
			}
			else {
				EB.userActionCounter("collapse_immersiveTakeover_user");
			}
			collapse();
			if (creativeId === "controls") {
				dispatchCustomScriptEvent("panelCollapsed", {
					animate: true
				});
				dispatchCustomScriptEvent("animateControlPos", {
					pos: collapsedPosition
				});
			}
		};

		var AnimationEnd = function(e) {
			document.body.removeEventListener("webkitAnimationEnd", AnimationEnd, false);
			document.body.removeEventListener("animationend", AnimationEnd, false);
			document.body.classList.remove("panelFadeIn");
			setStyle(document.body, {
				opacity: 1,
				display: "block"
			});
			switch (creativeId) {
				case "background":
					isFunctionCallBack("afterAnimationEnd", {
						isUserExpanded: isUserExpanded,
						isMobile: isMobile,
						isExpanded: isExpanded,
						isAutoExpand: isAutoExpand
					});
					break;
				case "videoskin":
					if (!isUnsupportedBrowserAutoPlay) {
						setTimeout(function() {
							playVideo();
						}, 300);
					}
					break;
			}
		};

		var onExpandAnimStart = function(e) {
			isFunctionCallBack("afterExpandAnimStart", {
				isUserExpanded: isUserExpanded,
				isMobile: isMobile,
				isExpanded: isExpanded,
				isAutoExpand: isAutoExpand,
				isIOS: isIOS
			});
			if (creativeId === "videoskin") {
				resizeVideoCrop(true);
			}
		};

		var onExpandAnimComplete = function(e) {
			if (creativeId === "header") {
				if (isAutoExpand) {
					startAutoCollapseTimer();
				}
			}
			isFunctionCallBack("afterExpandAnimComplete", {
				isUserExpanded: isUserExpanded,
				isMobile: isMobile,
				isExpanded: isExpanded,
				isAutoExpand: isAutoExpand,
				isIOS: isIOS
			});
			isExpanded = true;
			if (creativeId === "videoskin") {
				if (expandToFullScreen === true) {
					dispatchCustomScriptEvent("hidePanel", {
						panels: [headerPanelName, leftGutterName, rightGutterName]
					});
					setPanelZIndex(100001);
					seteyeDivZIndex(100003);
				}
				if (isMobile) {
					dispatchCustomScriptEvent("hidePanel", {
						panels: [headerPanelName]
					});
					setPanelZIndex(100001);
					seteyeDivZIndex(100003);
				}
				if (!isUnsupportedBrowserAutoPlay) {
					resizeVideoCrop(true);
				}
			}
		};

		var onCollapseAnimStart = function(e) {
			isAutoExpand = false;
			isCollapsing = true;
			isFunctionCallBack("afterCollapseAnimStart", {
				isUserExpanded: isUserExpanded,
				isMobile: isMobile,
				isExpanded: isExpanded,
				isAutoExpand: isAutoExpand
			});
			if (creativeId === "videoskin") {
				if (expandToFullScreen === true) {
					dispatchCustomScriptEvent("showPanel", {
						panels: [headerPanelName, leftGutterName, rightGutterName]
					});
					setPanelZIndex(-5);
					seteyeDivZIndex(10000);
				}
				if (isMobile) {
					dispatchCustomScriptEvent("showPanel", {
						panels: [headerPanelName, controlPanelName]
					});
					setPanelZIndex(-5);
					seteyeDivZIndex(10000);
				}
			}
		};

		var onCollapseAnimComplete = function(e) {
			clearAutoCollapseTimer();
			isCollapsing = false;
			isFunctionCallBack("afterCollapseAnimComplete", {
				isUserExpanded: isUserExpanded,
				isMobile: isMobile,
				isExpanded: isExpanded,
				isAutoExpand: isAutoExpand
			});
			if (creativeId === "videoskin") {
				if (!isUnsupportedBrowserAutoPlay) {
					resizeVideoCrop(isExpanded);
				}
			}
		};
		/*************************************
					SYNCHRONIZE
		*************************************/
		var syncGutterLeft = function() {
			dispatchCustomScriptEvent("animateLeft", {});
		};
		var syncGutterRight = function() {
			dispatchCustomScriptEvent("animateRight", {});
		};
		var syncAllPanels = function(state) {
			dispatchCustomScriptEvent("animateAll", {
				state: state
			});
		};
		var syncAll = function(state) {
			isFunctionCallBack("syncAll", {
				state: state
			});
		};
		/*************************************
		End HTML5 Event System - Do Not Modify
		*************************************/
		var seteyeDivZIndex = function(zindex) {
			setZindex("eyediv", zindex);
		};

		var setPanelZIndex = function(zindex) {
			if (adkit.environment.adParts) {
				setZindex(adkit.environment.adParts.name, zindex);
			}
		};

		var setZindex = function(name, zindex) {
			dispatchCustomScriptEvent("updatePanelZIndex", {
				panelName: name,
				zIndex: zindex
			});
		};

		var creativeContainerReady = function() {
			if (creativeId !== "banner") {
				dispatchCustomScriptEvent("panelLoaded");
			}
			//addCustomScriptEventListener("pageScroll", onPageScroll);
			isFunctionAddCustomScriptEventListener("panelUnload", "onPanelUnload");
			isFunctionAddCustomScriptEventListener("panelLoad", "onPanelLoaded");
			switch (creativeId) {
				case "header":
					//Sync
					addCustomScriptEventListener("videoEnd", onVideoEnd);
					addCustomScriptEventListener("clearAutoCollapse", disableAutoExpand);
					addCustomScriptEventListener("expandAnimStart", onExpandAnimStart);
					addCustomScriptEventListener("expandAnimComplete", onExpandAnimComplete);
					addCustomScriptEventListener("collapseAnimStart", onCollapseAnimStart);
					addCustomScriptEventListener("collapseAnimComplete", onCollapseAnimComplete);
					document.addEventListener("mousedown", disableAutoExpand);
					break;
				case "controls":
					//init position
					dispatchCustomScriptEvent("positionControls", {
						pos: "top-right"
					});
					addCustomScriptEventListener("videoPlay", onVideoPlay);
					addCustomScriptEventListener("videoPause", onVideoPause);
					addCustomScriptEventListener("videoEnd", onVideoEnd);
					addCustomScriptEventListener("videoVolumeChange", onVideoVolumeChange);
					addCustomScriptEventListener("panelExpanded", onPanelExpanded);
					addCustomScriptEventListener("panelCollapsed", onPanelCollapsed);
					addCustomScriptEventListener("expandAnimStart", onExpandAnimStart);
					addCustomScriptEventListener("expandAnimComplete", onExpandAnimComplete);
					addCustomScriptEventListener("collapseAnimStart", onCollapseAnimStart);
					addCustomScriptEventListener("collapseAnimComplete", onCollapseAnimComplete);
					document.addEventListener("mousedown", clearAutoCollapseTimer);
					break;
			}
		};

		var onPageScroll = function(event) {
			isFunctionCallBack("onPageScroll", {
				isUserExpanded: isUserExpanded,
				isMobile: isMobile,
				isExpanded: isExpanded,
				isAutoExpand: isAutoExpand,
				scrollXPercent: event.scrollXPercent,
				scrollYPercent: event.scrollYPercent
			});
			displayDimensions();
		};
		/*******************
		END OF CREATIVE FUNCTIONS
		*******************/
		/*******************
		UTILITIES
		*******************/
		var fontResize = function(elemRef, minFontSize) {
			var _compressor = 0.7;
			var _maxFontSize = 15;
			var _minFontSize = minFontSize;
			if (elemRef) {
				var fontS = Math.max(Math.min(elemRef.offsetWidth / (_compressor * 10), parseFloat(_maxFontSize)), parseFloat(_minFontSize));
				elemRef.style.fontSize = fontS + "px";
			}
		};

		var onClickThroughFired = function() {
			isFunctionCallBack("adWasClicked", {
				isIOS: isIOS,
				isUserExpanded: isUserExpanded,
				isMobile: isMobile,
				isExpanded: isExpanded,
				isAutoExpand: isAutoExpand
			});
			if (!isUserExpanded || !userInteraction) clearAutoCollapseTimer();

		};

		var trackVideoInteractions = function(video) {
			videoTrackingModule = new EBG.VideoModule(video);
		};

		var initVideo = function(videoContainerElement) {
			log("initVideo: " + creativeId);

			var vidSrc = videoConfig.videoURL;
			var vidPoster = videoConfig.videoPoster;

			videoContainer = videoContainerElement || document.getElementById("video-container");

			video = document.createElement("video");
			video.id = "video";
			video.setAttribute("webkit-playsinline", "");
			video.setAttribute("playsinline", "");
            video.setAttribute("autoplay", "");
            video.muted = true;
            video.setAttribute("muted", "");
            video.setAttribute("autoplay", "");
            video.setAttribute("poster", vidPoster);			

			if (Array.isArray(vidSrc)) {
				for (var i = 0; i < vidSrc.length; i++) {
					video.appendChild(createVideoSrcTag(vidSrc[i]));
				}
			}
			else {
				video.appendChild(createVideoSrcTag(vidSrc));
			}

			// In some environments, such as some MRAID environemnts, we have seen autoplay video refuse to play without this additional call to video.play() fired after/within the oncanplay event.
			// Should this issue arise in the future please try uncomminting the blow.
			// video.oncanplay = function(){
			// 	video.play();
			// } commented out but left in for possible future use.

			videoContainer.appendChild(video);

			trackVideoInteractions(video);
			video.addEventListener("ended", onVideoEnd);
			video.addEventListener("play", onVideoPlay);
			video.addEventListener("pause", onVideoPause);
			video.addEventListener("volumechange", onVideoVolumeChange);

			isFunctionCallBack("afterVideoReady", {
				isUserExpanded: isUserExpanded,
				isMobile: isMobile,
				isExpanded: isExpanded,
				isAutoExpand: isAutoExpand,
				video: video
			});

			function createVideoSrcTag(src) {
				var splitStr = src.split(".");
				var fileExt = splitStr[splitStr.length - 1];

				var srcTag = document.createElement("source");
				srcTag.setAttribute("src", src);
				srcTag.setAttribute("type", ("video/" + (fileExt === "ogv" ? "ogg" : fileExt)));

				return srcTag;
			};
		};

		var resizeVideo = function(videoContainerElement) {
			if (!video) return;

			var finalwh = calculateAspectRatioFit(videoConfig.width, videoConfig.height, videoContainerElement.offsetWidth, videoContainerElement.offsetHeight);
			if (finalwh.width < videoContainerElement.offsetWidth) {
				video.style.width = "100%";
				video.style.height = "100%";
				video.style.marginTop = "";
			}
			else {
				video.style.width = finalwh.width + "px";
				video.style.height = finalwh.height + "px";
				video.style.marginTop = ((videoContainerElement.offsetHeight / 2) - (finalwh.height / 2)) + "px";
			}
		};

		var pauseVideo = function() {
			try {
				video.pause();
			}
			catch (e) {}
		};

		var playVideo = function() {
			try {
				video.style.opacity = "1";
				setTimeout(function() {
					videoTrackingModule.playVideo(false);
				}, 200);
			}
			catch (e) {}
		};

		var toggleVideoPlay = function(isVideoPlaying) {
			dispatchCustomScriptEvent("toggleVideoPlay", {
				playVideo: isVideoPlaying
			});
		};

		var toggleAudio = function(isAudioMute) {
			dispatchCustomScriptEvent("toggleAudio", {
				muteAudio: isAudioMute
			});
		};

		var onVideoEnd = function(e) {
			if (creativeId !== "controls") {
				if (isMobile || isUserExpanded) {
					if (isUnsupportedBrowserAutoPlay) {
						clearAutoCollapseTimer();
					}
				}
			}
			//to fix a bug in IE11 windows7
			pauseVideo();
			isFunctionCallBack("afterVideoEnd", {
				isUserExpanded: isUserExpanded,
				isMobile: isMobile,
				isExpanded: isExpanded,
				isAutoExpand: isAutoExpand,
				video: video
			});
		};

		var onVideoPlay = function(e) {
			log("onVideoPlay: " + creativeId + " - isUserExpanded: " + isUserExpanded + " - userInteraction: " + userInteraction);
			if (creativeId !== "controls") {
				if (isExpanded) {
					if (isMobile || isUserExpanded) {
						if (isUnsupportedBrowserAutoPlay) {
							clearAutoCollapseTimer();
						}
					}
				}
			}
			if (creativeId === "videoskin") {
				dispatchCustomScriptEvent("videoPlay", {});
			}
			isFunctionCallBack("afterVideoPlay", {
				isUserExpanded: isUserExpanded,
				isMobile: isMobile,
				isExpanded: isExpanded,
				isAutoExpand: isAutoExpand,
				video: video
			});
		};

		var onVideoPause = function(e) {
			log("onVideoPause: " + creativeId + " - isUserExpanded: " + isUserExpanded + " - userInteraction: " + userInteraction);
			if (creativeId !== "controls") {
				clearAutoCollapseTimer();
			}
			if (creativeId === "videoskin") {
				dispatchCustomScriptEvent("videoPause", {});
			}
			isFunctionCallBack("afterVideoPause", {
				isUserExpanded: isUserExpanded,
				isMobile: isMobile,
				isExpanded: isExpanded,
				isAutoExpand: isAutoExpand,
				video: video
			});
		};

		var onVideoVolumeChange = function(e) {
			log("onVideoVolumeChange: " + creativeId + " - isUserExpanded: " + isUserExpanded + " - userInteraction: " + userInteraction);
			if (creativeId !== "controls") {
				if (isExpanded) {
					clearAutoCollapseTimer();
				}
			}
			if (typeof video === "undefined" || e.muted) {
				dispatchCustomScriptEvent("videoVolumeChange", {
					muted: video.muted
				});
			}
			isFunctionCallBack("afterVolumeChange", {
				isAudioMute: e.muted,
				isUserExpanded: isUserExpanded,
				isMobile: isMobile,
				isExpanded: isExpanded,
				isAutoExpand: isAutoExpand
			});
		};

		var resizeVideoCrop = function(fullViewPortHeight) {
			if (isUnsupportedBrowserAutoPlay && isMobile) return;
			var resizeV = full_bleed(videoContainer.offsetWidth, videoContainer.offsetHeight, videoConfig.width, videoConfig.height);
			video.style.width = resizeV.width + "px";

			if (fullViewPortHeight) {
				video.style.height = (resizeV.height) + "px";
			}
			else {
				video.style.height = (resizeV.height + bannerYMobile) + "px";
			}
			video.style.top = "0px";
			video.style.left = -((resizeV.width / 2) - (videoContainer.offsetWidth / 2)) + "px";
			if (isMobile && !isExpanded && !fullViewPortHeight) {
				if (videoContainer.offsetWidth < videoContainer.offsetHeight && videoContainer.offsetWidth < 690) {
					video.style.top = -((resizeV.height / 2) - (bannerHeightMobile / 2)) + "px";
				}
			}
		};

		var calculateAspectRatioFit = function(srcWidth, srcHeight, maxWidth, maxHeight) {
			var ratio = Math.min(maxWidth / srcWidth, maxHeight / srcHeight);
			return {
				width: srcWidth * ratio,
				height: srcHeight * ratio
			};
		};

		var changePageBackground = function(img, color, size, position, attach, repeat, fade, fade_time, inject, injectType, clickable) {
			var config = {
				img: img,
				color: color,
				size: size,
				position: position,
				attach: attach,
				repeat: repeat,
				fade: fade,
				fade_time: fade_time,
				inject: inject,
				injectType: injectType,
				clickable: clickable
			};
			dispatchCustomScriptEvent("changePageBackground", config);
		};

		var injectBreakPoints = function(breakpointsBackgroundsList) {
			var objBreakPoints = {};
			objBreakPoints.bkgList = breakpointsBackgroundsList;
			dispatchCustomScriptEvent("injectBreakPoints", objBreakPoints);
		};

		var loadAdditionalAsset = function(element, additionalAsset, localBackground) {
			var img = document.createElement("img");
			img.src = EB.getAssetUrl(localBackground, additionalAsset);
			element.appendChild(img);
		};

		var isFunctionCallBack = function(nameFunction, actionType) {
			var args = [];
			try {
				args = actionType;
				if (typeof window[nameFunction] === "function") {
					window[nameFunction](args);
				}
			}
			catch (e) {}
		};

		var isFunctionAddCustomScriptEventListener = function(nameFunction, callBackFunction) {
			if (typeof window[callBackFunction] === "function") {
				addCustomScriptEventListener(nameFunction, window[callBackFunction]);
			}
		};

		var full_bleed = function(boxWidth, boxHeight, imgWidth, imgHeight) {
			// Calculate new height and width…
			var initW = imgWidth;
			var initH = imgHeight;
			var ratio = initH / initW;
			imgWidth = boxWidth;
			imgHeight = boxWidth * ratio;
			// If the video is not the right height, then make it so…
			if (imgHeight < boxHeight) {
				imgHeight = boxHeight;
				imgWidth = imgHeight / ratio;
			}
			//  Return new size for video
			return {
				width: imgWidth,
				height: imgHeight
			};
		};

		var trackGutters = function() {
			if (!EB._adConfig[autoEventName]) {
				EB.automaticEventCounter(autoEventName);
				EB.API.setCustomVar(autoEventName, true, true);
			}
			else {
				animDelay = 0;
				showPanelContent();
			}
		};

		var setStyle = function(a, f) {
			if (EB.API && EB.API.setStyle) {
				EB.API.setStyle(a, f);
			}
			else {
				for (var c in f) {
					if (a) {
						f.hasOwnProperty(c) && (a.style[c] = f[c]);
					}
				}
			}
		};

		var animate = function(elem, style, unit, from, to, time, isTransform, callback) {
			if (!elem) return;
			var start = new Date().getTime(),
				timer = setInterval(function() {
					var step = Math.min(1, (new Date().getTime() - start) / time);
					if (isTransform) {
						if (EB.API.browser.ie && EB.API.browser.ver == 9) {
							elem.style.msTransform = (style + "(" + (from + step * (to - from)) + unit + ")");
						}
						else {
							elem.style.transform = (style + "(" + (from + step * (to - from)) + unit + ")");
						}
					}
					else {
						elem.style[style] = (from + step * (to - from)) + unit;
					}
					if (step == 1) {
						clearInterval(timer);
						if (typeof callback !== "undefined") {
							callback();
						}
					}
				}, 25);
			if (isTransform) {
				elem.style.transform = (style + "(" + from + unit + ")");
			}
			else {
				elem.style[style] = from + unit;
			}
		};

		/*******************
		UTILITIES
		*******************/
		function displayDimensions() {
			if (dimensions) {
				var iw = window.innerWidth,
					ih = window.innerHeight,
					sx = scrollPos.x,
					sy = scrollPos.y;
				var str = "<br>Viewport: " + iw + "x" + ih + " | <span style='display:block'>Scroll (X: " + sx + "%; Y: " + sy + "%)</span>";
				dimensions.innerHTML = str;
			}
		}

		function setCreativeVersion() {
			sendMessage("setCreativeVersion", {
				creativeId: creativeId,
				creativeVersion: creativeVersion,
				creativeLastModified: lastModified,
				uid: uid
			});
		}

		/*********************************
		HTML5 Event System - Do Not Modify
		*********************************/
		var sendMessage = function(type, data) {

			//note: the message type we're sending is also the name of the function inside
			//		the custom script's messageHandlers object, so the case must match.

			if (!data.type) data.type = type;
			EB._sendMessage(type, data);
		};

		var addCustomScriptEventListener = function(eventName, callback, interAd) {
			listenerQueue = listenerQueue || {};
			var data = {
				uid: uid,
				listenerId: Math.ceil(Math.random() * 1000000000),
				eventName: eventName,
				interAd: !!(interAd),
				creativeIFrameId: creativeIFrameId
			};
			sendMessage("addCustomScriptEventListener", data);
			data.callback = callback;
			listenerQueue[data.listenerId] = data;
			return data.listenerId;
		};

		var dispatchCustomScriptEvent = function(eventName, params) {
			if (isLocal) return;
			try {
				params = params || {};
				params.uid = uid;
				params.eventName = eventName;
				params.creativeIFrameId = creativeIFrameId;
				sendMessage("dispatchCustomScriptEvent", params);
			}
			catch (e) {}
		};

		var removeCustomScriptEventListener = function(listenerId) {
			if (isLocal) return;
			var params = {
				uid: uid,
				listenerId: listenerId,
				creativeIFrameId: creativeIFrameId
			};

			sendMessage("removeCustomScriptEventListener", params);
			if (listenerQueue[listenerId])
				delete listenerQueue[listenerId];
		};

		var eventManager = function(event) {
			if (isLocal) return;
			var msg;
			try {
				if (typeof event == "object" && event.data) {
					msg = JSON.parse(event.data);
				}
				else {
					// this is safe frame.
					msg = {
						type: event.type,
						data: event
					};
				}
				if (msg.type && msg.data && (!uid || (msg.data.uid && msg.data.uid == uid))) {
					switch (msg.type) {
						case "sendCreativeId":
							creativeIFrameId = msg.data.creativeIFrameId;
							creativeId = typeof config.panel != "undefined" && config.panel !== "" ? config.panel : "banner";
							if (creativeId !== "banner") {
								showPanelContentID = addCustomScriptEventListener("showPanelContent", showPanelContent);
							}
							if (creativeId === "videoskin") {
								sendMessage("setTemplateType", {
									isVideowall: true,
									uid: uid
								});
							}
							addCustomScriptEventListener('pageScroll', onPageScroll);
							sendMessage("dispatchScrollPos", {
								uid: uid
							});
							//data for VideoSkin
							if (EB.API.os.mobile) {
								if (msg.data.pageShimY) {
									bannerYMobile = msg.data.pageShimY;
								}
								if (msg.data.pageShimHeight) {
									bannerHeightMobile = msg.data.pageShimHeight;
								}
							}
							if (creativeContainerReady) creativeContainerReady();
							setCreativeVersion();
							break;
						case "eventCallback": // Handle Callback
							var list = msg.data.listenerIds;
							var length = list.length;
							for (var i = 0; i < length; i++) {
								try {
									var t = listenerQueue[list[i]];
									if (!t) continue;
									t.callback(msg.data);
								}
								catch (e) {}
							}
							break;
					}
				}
			}
			catch (e) {}
		};

		// Debugging
		var log = function() { // this is a closure-compiled version of the original code
			if (isDebug) {
				var b, a;
				b = Array.prototype.slice.call(arguments);
				a = new Date();
				a = scriptName + " (" + a.getFullYear() + "-" + a.getMonth() + "-" + a.getDate() + " " + (("0" + a.getHours()).slice(-2)) + ":" + (("0" + a.getMinutes()).slice(-2)) + ":" + (("0" + a.getSeconds()).slice(-2)) + "." + (("00" + a.getMilliseconds()).slice(-3)) + "): ";
				b.unshift(a);
				try {
					window.console && console.log && (console.log.apply ? console.log.apply(console, b) : console.log(b));
				}
				catch (d) {}
			}
		};
		// Return functions you want publically available
		return {
			addEventListener: addEventListener,
			removeEventListener: removeEventListener,
			init: init,
			expand: expand,
			onExpandClick: onExpandClick,
			closePanel: closePanel,
			onCollapseClick: onCollapseClick,
			initVideo: initVideo,
			resizeVideo: resizeVideo,
			toggleVideoPlay: toggleVideoPlay,
			toggleAudio: toggleAudio,
			fontResize: fontResize,
			animate: animate,
			setStyle: setStyle,
			injectBreakPoints: injectBreakPoints,
			changePageBackground: changePageBackground,
			loadAdditionalAsset: loadAdditionalAsset,
			syncGutterLeft: syncGutterLeft,
			syncGutterRight: syncGutterRight,
			syncAllPanels: syncAllPanels,
			setPanelZIndex: setPanelZIndex,
			setZindex: setZindex,
			seteyeDivZIndex: seteyeDivZIndex,
			getInfo: getInfo,
			closeAllPanels: closeAllPanels
		};
	};
}());
